package vn.azteam.tpf.service.dto;

import java.io.Serializable;
import java.util.Objects;
import io.github.jhipster.service.filter.BooleanFilter;
import io.github.jhipster.service.filter.DoubleFilter;
import io.github.jhipster.service.filter.Filter;
import io.github.jhipster.service.filter.FloatFilter;
import io.github.jhipster.service.filter.IntegerFilter;
import io.github.jhipster.service.filter.LongFilter;
import io.github.jhipster.service.filter.StringFilter;

/**
 * Criteria class for the TBObjectUpdate entity. This class is used in TBObjectUpdateResource to
 * receive all the possible filtering options from the Http GET request parameters.
 * For example the following could be a valid requests:
 * <code> /tb-object-updates?id.greaterThan=5&amp;attr1.contains=something&amp;attr2.specified=false</code>
 * As Spring is unable to properly convert the types, unless specific {@link Filter} class are used, we need to use
 * fix type specific filters.
 */
public class TBObjectUpdateCriteria implements Serializable {

    private static final long serialVersionUID = 1L;

    private LongFilter id;

    private StringFilter index;

    private IntegerFilter times;

    private LongFilter tbObjectParameterId;

    private LongFilter tbActivityId;

    public LongFilter getId() {
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public StringFilter getIndex() {
        return index;
    }

    public void setIndex(StringFilter index) {
        this.index = index;
    }

    public IntegerFilter getTimes() {
        return times;
    }

    public void setTimes(IntegerFilter times) {
        this.times = times;
    }

    public LongFilter getTbObjectParameterId() {
        return tbObjectParameterId;
    }

    public void setTbObjectParameterId(LongFilter tbObjectParameterId) {
        this.tbObjectParameterId = tbObjectParameterId;
    }

    public LongFilter getTbActivityId() {
        return tbActivityId;
    }

    public void setTbActivityId(LongFilter tbActivityId) {
        this.tbActivityId = tbActivityId;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TBObjectUpdateCriteria that = (TBObjectUpdateCriteria) o;
        return
            Objects.equals(id, that.id) &&
            Objects.equals(index, that.index) &&
            Objects.equals(times, that.times) &&
            Objects.equals(tbObjectParameterId, that.tbObjectParameterId) &&
            Objects.equals(tbActivityId, that.tbActivityId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
        id,
        index,
        times,
        tbObjectParameterId,
        tbActivityId
        );
    }

    @Override
    public String toString() {
        return "TBObjectUpdateCriteria{" +
                (id != null ? "id=" + id + ", " : "") +
                (index != null ? "index=" + index + ", " : "") +
                (times != null ? "times=" + times + ", " : "") +
                (tbObjectParameterId != null ? "tbObjectParameterId=" + tbObjectParameterId + ", " : "") +
                (tbActivityId != null ? "tbActivityId=" + tbActivityId + ", " : "") +
            "}";
    }

}
